# Copyright (C) 2003-2006 Ingeniweb SAS

# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE

# More details in the ``LICENSE`` file included in this package.

"""
    Plone Article migration module
"""

from Products.PloneArticle.migration import applyArticles
#from Products.PloneArticle.interface.innercontentfield import IBaseInnerContentField
from Products.PloneArticle.interface.innercontentwidget import IBaseInnerContentWidget
from Products.PloneArticle.widget.baseinnercontent import BaseInnerContentWidget


###############################################################################

def v4_0_2_v4_0_3(portal):
    """4.0.2 to 4.0.3"""
    out = []

    def fixBaseInnerWidgetProperties(article):
        ## Add new properties needed by widget rendering
        for widget in article.Schema().widgets().values():
            if isinstance(widget, BaseInnerContentWidget):
                widget._properties.update({
                    'hide_upload_link'  : False,
                    'hide_browser_link' : False,
                })

    applyArticles(portal, fixBaseInnerWidgetProperties)
    out.append("Add hide_upload_link and hide_browser_link widget properties "
               "on older articles")

    return out