Article = {
	url: null,
	type: null,
	unload_protection_activated: false,
	activateUnloadProtection:  function() {
		if (this.unload_protection_activated) {
			$('#pa_unload_protection_flag').val(1);
		}
	}
};

Proxy = {
	current: null,
	timeout: null,
	type: null,
	article_url: null
};

Proxy.move = function(widget_id, delta) {
	var widget_node = document.getElementById(widget_id);
	var parent_node = widget_node.parentNode;
	// Move node
	if (delta < 0) {
		var prev = $(widget_node).prev().get(0);
		if (prev)
				parent_node.insertBefore(widget_node, prev);
	} else {
		var next = $(widget_node).next().get(0);
		if (next)
			parent_node.insertBefore(next, widget_node);		
	}
	Proxy.refresh(true);
};

Proxy.moveToTop = function(widget_id) {
	var widget_node = document.getElementById(widget_id);
	var parent_node = widget_node.parentNode;
	$(parent_node).prepend(widget_node);
	Proxy.refresh(true);
};

Proxy.moveToBottom = function(widget_id) {
	var widget_node = document.getElementById(widget_id);
	var parent_node = widget_node.parentNode;
	parent_node.appendChild(widget_node); 
	Proxy.refresh(true);
};

Proxy.onMouseDown = function(e) {
	var proxy = $(this).parents('.innerContentWidget').get(0);
	Proxy.current = proxy;
	Proxy.lastTarget = null;
	Proxy.timeout = window.setTimeout(function() {
    Proxy.timeout = window.clearTimeout(Proxy.timeout);
    document.body.style.cursor = 'move !important';
    $(proxy).addClass('dragging');
    $(proxy.parentNode).bind('mousemove', Proxy.drag);
	}, 50);
	$(document.body).bind('mouseup', Proxy.drop);
	return true;
};

Proxy.drag = function(e) {
	var e = e || fixEvent(window.event);
	e.stopPropagation();
	var proxy = Proxy.current;
	var target = e.target || e.srcElement;
	var y = e.clientY + document.documentElement.scrollTop;
	target = $(target).parents('.innerContentWidget').get(0);
	if (proxy.offsetTop > target.offsetTop) {
    // dropped above target: insert before
 		proxy.parentNode.insertBefore(proxy, target);
  } else {
    //insert after target or at last position
    var next = target.nextSibling;
    if (next && next.nodeType == 3) next = next.nextSibling;
 		if (next) {
 			try {
      	proxy.parentNode.insertBefore(proxy, next);
      } catch(ex) {}
    } else {
    	proxy.parentNode.appendChild(proxy);
    }
  }
};

Proxy.drop = function(e) {
	var e = e || window.event;
	var proxy = Proxy.current;
	Proxy.current = null;
 	document.body.style.cursor = '';
 	$(proxy).removeClass('dragging');
 	$(proxy.parentNode).unbind('mousemove', Proxy.drag);
 	$(document.body).unbind('mouseup', Proxy.drop); 	
	if (Proxy.timeout) {
		Proxy.timeout = window.clearTimeout(Proxy.timeout);
		return true;
	}
	var y = e.clientY + document.documentElement.scrollTop;
	var position = 0;
	$('.innerContentWidget', proxy.parentNode).each(function(index) {
		if (proxy == this)
			return position = index;
	});
	Proxy.refresh(true);
};

Proxy.removeRemove = function(widget_id) {
	var widget_node = document.getElementById(widget_id);
	var parent_node = widget_node.parentNode;
	parent_node.removeChild(widget_node);
	Proxy.refresh(true);
};

Proxy.saveForm = function() {
   var frm = $(Proxy.container).parents('form')[0];
   var formData = $('input:not([@type=submit]), textarea', frm).serialize();
  $.ajax({
       type: 'POST',
       url: 'processForm',
       data: formData });
  $('#pa_unload_protection_flag').val(0);
}

Proxy.sendForm = function() {
  var text_input = $('#new_file')[0] || $('#new_url')[0];
	if (text_input) {
    if (!text_input.value.length) {
	    alert($('#new_file_noinput').text());
	    return false ;
    }
		// Set the interface elements.		
		$('#new_file_waitingMessage').show();
		$('#new_file_btn_ok')[0].disabled = true;		
		text_input.form.submit();
		// clean only after submit (important)
		$('#new_file_uploadContent').html('');
		$('#new_file_uploadResult').html('');
	}
	return false;
};

Proxy.uploadCompleted = function() {
	var container = $('#proxyContainer')[0];
	var doc = container.ownerDocument;
	var iframe_doc = $('#frmUploadWorker')[0].contentWindow.document;
	$('#new_file_waitingMessage').hide();

	var inner_widgets = $('div.innerContentWidget', iframe_doc);	
  var widget_added = false;
	for (var i=0; i < inner_widgets.length; i++) {
	    // because of IE we just can't move the nodes from the IFRAME: it is in
	    // another tree...  thus we need to create a copy
	    var new_widget = inner_widgets[i];
	    
	    var new_div = document.createElement("DIV"); 
	    new_div.setAttribute('id', new_widget.id);
	    new_div.className = new_widget.className;
	    new_div.innerHTML = new_widget.innerHTML;
	    
	    // this convert HTML to a DOM element. Required in order to find (by
	    // script) later our new elements. Thickbox scripts will look for images
	    // in widget, for instance
	    //jQuery.clean(new_div);
	
	    $(container).append(new_div);
	    widget_added = true;
	}

	$('#new_file_uploadResult, #new_file_uploadContent', doc).empty();
	$('#new_file_uploadResult', doc).html($('div#upload-status', iframe_doc).html());
	$('#new_file_uploadContent', doc).html($('div#upload-informations', iframe_doc).html());
	
	// Reset the Upload Worker Frame.
	$('#frmUploadWorker').attr('src', 'about:blank');
	
	// Reset the upload form
	$('#frmUpload', doc)[0].reset();
	$('#new_file_btn_ok', doc)[0].disabled = false;
	
	if (widget_added) {
    window.Proxy.refresh();
    TB_unlaunch();
    TB_launch();
  }
};

Proxy.toggleFullDisplay = function(widget_id) {
	var widget = $('#' + widget_id);
	widget.toggleClass('closedContent');
	if (widget.is('.closedContent')) {
		$('input[@type=text]', widget).each(function() {
			$(this).hide().after('<span>' + this.value + '<span>');
		});
	} else {
		$('input[@type=text]', widget).each(function() {
			$(this).show().next('span').remove();
		});
	}
};

Browser_init = function() {
	Browser.maximize = function() {
		Browser.maximized = true;
		var size = {};
		var proxyContainer = $('#proxyContainer')[0];
		size.left = findPosX(proxyContainer) + 130;
		size.top = 100 ;
		arrayPageSize = getPageSize();
		var screenWidth = arrayPageSize [2];
		var screenHeight =arrayPageSize [3];
		size.width = screenWidth - size.left - 30;
		size.height = screenHeight - 110;
		Browser.size(size); 		 
    window.scroll(0,size.top-30); 	   
	};
	Browser.selectItem = function (UID) {
	  aUrl = Browser.url + '/' + Browser.reference_script;
	  $('.statusBar > div', Browser.window).hide().filter('#msg-loading').show();
    $.post(aUrl, {uid: UID, field_name: Browser.field_name},
          function(data) {          	
	          var container = $('#proxyContainer');
	          container.append(data);
	          $(document).ready(TB_unlaunch);
	          $(document).ready(TB_launch);
	          Proxy.refresh();
	         	$('.statusBar > div', Browser.window).hide().filter('#msg-done').show();
          });
	};
  Browser.open = function(path, searchTerm, scope, replaceId, replacePath) {
    var aUrl = 'pa_browser';
  	var data = {
          field_name:  Browser.field_name,
          path : 			 path,
          type: 			 Browser.type,
          typeView: 	 Browser.typeView,
          searchTerm:  searchTerm,
          scope: 			 scope,
          replaceId: 	 replaceId,
          replacePath: replacePath
    };
    data.path = encodeURI(data.path || '');
    Browser.options = data;
    $('.statusBar > div', Browser.window).hide().filter('#msg-loading').show();
  	$.post(aUrl, data, function(html) {
  		Browser.close();
  		$(document.body).append(html);
  	  $('#plone-browser').popup();
  		Browser.window = $('#plone-browser > .window');
  		$('#plone-browser-tab').mousedown(Browser.setMovable);
  		$('#plone-browser-corner-resize').mousedown(Browser.setResizable);
  		if (Browser.maximized)
  		    Browser.maximize();
  		  else
  		  	Browser.size(Browser.top, Browser.left, Browser.width, Browser.height);	 
      $('.statusBar > div', Browser.window).hide().filter('#msg-loading').hide();
      $("#plone-browser .overlay").click(Browser.close);
  		TB_unlaunch();
  		TB_launch();		  		  
      $(window).resize(function() {Browser.maximize();});		
      Browser.batch();
    });
  };	
	Browser.type = Browser.typeView = Article.type;
	Browser.url = Article.url;
  Browser.field_name = $('#pa_browser_fieldName').val();
  Browser.reference_script = $('#pa_browser_reference_script').val();
  Browser.maximized = true;
};

Proxy.refresh = function(saveForm) {
	$(".innerContentWidget").removeClass('even').removeClass('odd');
	$(".innerContentWidget:nth-child(even)", Proxy.container).addClass("even");	
	$(".innerContentWidget:nth-child(odd)", Proxy.container).addClass("odd");		
  $('.file_handle', Proxy.container).mousedown(Proxy.onMouseDown);
  if ($('.innerContentWidget', Proxy.container).length == 1)
    $('.emptyContainer', Proxy.container).show();
  else
    $('.emptyContainer', Proxy.container).hide();
  Article.activateUnloadProtection();
  if (saveForm)
    Proxy.saveForm();
};


Proxy_init = function() {
	Proxy.container = $('#proxyContainer')[0];
	$('.innerContentWidget.closedContent input[@type=text]', Proxy.container).each(function() {
		$(this).hide().after('<span>' + this.value + '<span>');
	});
	Proxy.refresh();
	Article.unload_protection_activated = true;
};


Article_init = function() {
	Article.type = $('#proxy_type').val();
	Article.url = $('#article_url').val();
	Browser_init();
	Proxy_init();
};

registerPloneFunction(Article_init);
